# Build with --debug (1) or --symbols (0)
%define debug   0
%define plugindir %{_libdir}/%{name}/plugins
%define libplugindir %{_libdir}/librnd/plugins

## NOTE This spec must be auto-generated.
# Only edit version, release and svn revision in here.
# See packaging.README for full details.
#
# The current librnd-devel package in the same Mga release system
# as building for and in, must be installed before auto updating
# the spec.
#
# For svn snapshot:
# Run './mk-tar' in SOURCES and note the svn revision # in output.
# In this spec. edit the '#define svn' to the new revision and
# replace '#' with percent sign if not already there.
#
# For full release:
# Get the new tarball
# Replace percent sign with '#' in '%%define svn' line
#
# Then for either full or snapshot release:
# Edit this spec to the new Version and Release, save and close.
# Now run './mk-spec @pkgname@' in SOURCES to re-create
# this spec file with any upstream changes.
##############################################

# Commented out if not svn snapshot
@svn-revision@

@release@

Name:           pcb-rnd
@version@
Release:        %mkrel %{?svn:0.%{svn}.}%{rel}
Summary:        Standard installation
License:        GPL-2.0-or-later and LGPL-2.0-or-later and BSD-1-Clause and MIT
Group:          Sciences/Other
URL:            http://repo.hu/projects/pcb-rnd
Source0:        %{URL}/releases/%{name}%{?svn:-%{svn}}%{!?svn:-%{version}}.tar.gz
Source1:        mk-tar
Source2:        %{name}.svg
Source3:        %{name}.desktop
Source4:        mk-spec
Source5:        spec.tpl
Source6:        packaging.README

BuildRequires:  gcc make
BuildRequires:  libfungw-devel libgenht-devel
BuildRequires:  librnd-devel >= 4.1.0
BuildRequires:  pkgconfig(freetype2)
BuildRequires:  pkgconfig(gdlib)
BuildRequires:  pkgconfig(glu)
BuildRequires:  pkgconfig(libxml-2.0)

@pcb-rnd-req@
Recommends:     %{name}-doc = %{version}-%{release}

Obsoletes:      %{name}-static < 2.2.4-2

%description

%package core
Summary:        @core-summary@
@pcb-rnd-core-req@

%description core
@core-desc@

%package doc
Summary:        @doc-summary@
BuildArch:      noarch

%description doc
@doc-desc@

%package auto
Summary:        @auto-summary@
@pcb-rnd-auto-req@

%description auto
@auto-desc@

%package cloud
Summary:        @cloud-summary@
Requires:       wget
@pcb-rnd-cloud-req@

%description cloud
@cloud-desc@

%package debug
Summary:        @debug-summary@
@pcb-rnd-debug-req@

%description debug
@debug-desc@

%package export-extra
Summary:        @export-extra-summary@
@pcb-rnd-export-extra-req@

%description export-extra
@export-extra-desc@

%package export-sim
Summary:        @export-sim-summary@
@pcb-rnd-export-sim-req@

%description export-sim
@export-sim-desc@

%package export
Summary:        @export-summary@
@pcb-rnd-export-req@

%description export
@export-desc@

%package extra
Summary:        @extra-summary@
@pcb-rnd-extra-req@

%description extra
@extra-desc@

%package import-geo
Summary:        @import-geo-summary@
@pcb-rnd-import-geo-req@

%description import-geo
@import-geo-desc@

%package import-net
Summary:        @import-net-summary@
@pcb-rnd-import-net-req@

%description import-net
@import-net-desc@

%package io-alien
Summary:        @io-alien-summary@
@pcb-rnd-io-alien-req@

%description io-alien
@io-alien-desc@

%package io-standard
Summary:        @io-standard-summary@
@pcb-rnd-io-standard-req@

%description io-standard
@io-standard-desc@

%package lib-gui
Summary:        @lib-gui-summary@
@pcb-rnd-lib-gui-req@

%description lib-gui
@lib-gui-desc@ 

%package lib-io
Summary:        @lib-io-summary@
@pcb-rnd-lib-io-req@

%description lib-io
@lib-io-desc@ 

%prep
%autosetup -n %{name}-%{?svn}%{!?svn:%{version}} -p1

%build
./configure --prefix=%{_usr} --libarchdir=%{_lib} --CFLAGS="%{build_cflags} -fno-lto" \
@MAIN_CONFIGURE_OPTIONS@\
%if %{debug} == 1
        prefix=%{_prefix} --debug
%else
        prefix=%{_prefix} --symbols
%endif

make

%install
%make_install

# Install icon
cp %{SOURCE2} .
mkdir -p %{buildroot}%{_iconsdir}/hicolor/scalable/apps
cp %{name}.svg %{buildroot}%{_iconsdir}/hicolor/scalable/apps/%{name}.svg

# Install Desktop files
mkdir -p %{buildroot}%{_datadir}/applications
cp %{SOURCE3} %{buildroot}%{_datadir}/applications/

%check

%files
# Meta-Package with desktop file
%{_datadir}/applications/%{name}.desktop

%files doc
%doc %{_docdir}/%{name}/

%files core
%{_iconsdir}/hicolor/scalable/apps/%{name}.svg
%{_datadir}/applications/%{name}.desktop
@core-files@

%files auto
@auto-files@

%files cloud
@cloud-files@

%files debug
@debug-files@
   
%files export-extra
@export-extra-files@

%files export-sim
@export-sim-files@

%files export
@export-files@

%files extra
@extra-files@

%files import-geo
@import-geo-files@

%files import-net
@import-net-files@

%files io-alien
@io-alien-files@

%files io-standard
@io-standard-files@

%files lib-gui
@lib-gui-files@

%files lib-io
@lib-io-files@

%changelog
* Mon Jan 20 2025 Pappy Packager <skrochen@krotek.com> - @version@-%{rel}
- Rebuilt for Fedora 41
